"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment = require("moment");
const build_intermediate_dependencies_1 = require("../../components/build_intermediate_dependencies");
const init_project_1 = require("../../components/init_project");
const watch_deps_1 = require("../../components/watch_deps");
const buildStatus_1 = require("../../config/buildStatus");
const env_1 = require("../../config/env");
const rearguard_1 = require("../../config/rearguard");
function sync() {
    return __awaiter(this, void 0, void 0, function* () {
        yield build_intermediate_dependencies_1.build_intermediate_dependencies(env_1.envConfig, rearguard_1.rearguardConfig);
        yield init_project_1.initProject();
        buildStatus_1.buildStatusConfig.last_build_time = moment();
        if (env_1.envConfig.isWatch) {
            watch_deps_1.watch_deps(env_1.envConfig, rearguard_1.rearguardConfig);
        }
    });
}
exports.sync = sync;
