"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const spawn = require("cross-spawn");
const path = require("path");
const typescript_1 = require("../config/typescript");
const const_1 = require("../const");
const index_1 = require("./sync/index");
function test() {
    return __awaiter(this, void 0, void 0, function* () {
        yield index_1.sync();
        typescript_1.typescriptTestConfig.init(true);
        const setup = path.resolve(__dirname, `../components/${const_1.TESTS_DIR_NAME}/setup.js`);
        const specs = path.resolve(process.cwd(), `${const_1.TESTS_DIR_NAME}/**/*.spec.ts`);
        const result = spawn.sync(`mocha`, [`--require`, `${setup}`, `${specs}`], { encoding: "utf8", stdio: "inherit" });
        if (result.signal) {
            if (result.signal === "SIGKILL") {
                console.log(chalk_1.default.red("The build failed because the process exited too early. " +
                    "This probably means the system ran out of memory or someone called `kill -9` on the process."));
                process.exit(1);
            }
            else if (result.signal === "SIGTERM") {
                console.log(chalk_1.default.bold.red("The build failed because the process exited too early. " +
                    "Someone might have called `kill` or `killall`, or the system could be shutting down."));
                process.exit(1);
            }
            process.exit(0);
        }
    });
}
test();
