"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const webpack = require("webpack");
const WDS = require("webpack-dev-server");
const build_intermediate_dependencies_1 = require("../components/build_intermediate_dependencies");
const init_project_1 = require("../components/init_project");
const watch_deps_1 = require("../components/watch_deps");
const env_1 = require("../config/env");
const rearguard_1 = require("../config/rearguard");
const wds_1 = require("../config/wds");
const get_WDS_config_1 = require("../webpack/components/get_WDS_config");
const webpack_config_main_1 = require("../webpack/webpack.config.main");
let watchDestroy;
let isRuning = false;
function wds() {
    return __awaiter(this, void 0, void 0, function* () {
        yield build_intermediate_dependencies_1.build_intermediate_dependencies(env_1.envConfig, rearguard_1.rearguardConfig);
        yield init_project_1.initProject();
        watchDestroy = yield watch_deps_1.watch_deps(env_1.envConfig, rearguard_1.rearguardConfig);
        const { host, port } = wds_1.wdsConfig;
        const server = new WDS(webpack(webpack_config_main_1.main_WS_config(env_1.envConfig, rearguard_1.rearguardConfig)), get_WDS_config_1.get_WDS_config(env_1.envConfig, rearguard_1.rearguardConfig));
        watch_deps_1.watch_deps_event_emitter.on("SYNCED", () => __awaiter(this, void 0, void 0, function* () {
            if (!isRuning) {
                isRuning = true;
                watchDestroy();
                yield build_intermediate_dependencies_1.build_intermediate_dependencies(env_1.envConfig, rearguard_1.rearguardConfig);
                watchDestroy = yield watch_deps_1.watch_deps(env_1.envConfig, rearguard_1.rearguardConfig);
                server.middleware.invalidate();
                server.middleware.waitUntilValid(() => {
                    isRuning = false;
                });
            }
            else {
                console.error(`[ WDS ][ SYNCED ][ ERROR ]`);
            }
        }));
        server.listen(port, host, () => {
            console.log(``);
            console.log(chalk_1.default.bold.cyanBright(`[ WDS ][ LAUNCHED ]`));
            console.log(chalk_1.default.cyan(`[ LAUNCHED: https://${host}:${port} ]`));
        });
    });
}
wds();
