"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const ora_1 = require("ora");
function check_npm() {
    return __awaiter(this, void 0, void 0, function* () {
        return yield new Promise((resolve) => {
            let timeout;
            const spinner = ora_1.default("Checking connection with npm registry").start();
            const childProcess = child_process_1.exec(`npm ping`, { encoding: "utf8" }, (error) => {
                clearTimeout(timeout);
                if (!error) {
                    spinner.succeed("Сonnection established with npm registry");
                    resolve(true);
                }
                else {
                    spinner.fail("Сonnection failure with npm registry");
                    resolve(false);
                }
                console.log("");
            });
            timeout = setTimeout(() => {
                spinner.fail("Сonnection failure with npm registry");
                console.log("");
                childProcess.kill();
                resolve(false);
            }, 10000);
        });
    });
}
exports.check_npm = check_npm;
