"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const del_1 = require("del");
const path = require("path");
const RearguardConfig_1 = require("../../config/rearguard/RearguardConfig");
const const_1 = require("../../const");
// tslint:disable:variable-name
function clear(envConfig, CWD) {
    return __awaiter(this, void 0, void 0, function* () {
        const { pkg } = new RearguardConfig_1.RearguardConfig(envConfig, path.resolve(CWD, "package.json"));
        const dll_bundle_dir = path.resolve(CWD, const_1.DLL_BUNDLE_DIR_NAME);
        const lib_bundle_dir = path.resolve(CWD, const_1.LIB_BUNDLE_DIR_NAME);
        const lib_dir = path.resolve(CWD, const_1.LIB_DIR_NAME);
        const node_modules = path.resolve(CWD, "node_modules");
        const dist = path.resolve(CWD, "dist");
        const delete_target = [node_modules, dist, dll_bundle_dir, lib_bundle_dir, lib_dir];
        const paths = yield del_1.default(delete_target);
        for (const item of paths) {
            console.log(chalk_1.default.gray(`[ ${pkg.name} ][ REMOVE ][ ${item} ]`));
        }
        console.log("");
    });
}
exports.clear = clear;
// tslint:enable:variable-name
