"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const spawn = require("cross-spawn");
const path = require("path");
const env_1 = require("../../config/env");
const RearguardConfig_1 = require("../../config/rearguard/RearguardConfig");
const install_declared_deps_1 = require("../project_deps/install_declared_deps");
function install(CWD) {
    return __awaiter(this, void 0, void 0, function* () {
        const { pkg } = new RearguardConfig_1.RearguardConfig(env_1.envConfig, path.resolve(CWD, "package.json"));
        console.log(chalk_1.default.bold.green(`[ ${pkg.name} ][ INSTALL ]`));
        console.log("");
        // ! Необходимо запомнить текущее значение, для того чтобы его
        // ! восстановить в конце процедуры.
        const NODE_ENV = process.env.NODE_ENV;
        process.env.NODE_ENV = "development";
        yield install_declared_deps_1.install_declared_deps(env_1.envConfig, CWD);
        const result = spawn.sync("npm", ["install"], {
            cwd: CWD,
            encoding: "utf8",
            stdio: "inherit",
        });
        // ! Обработка сигнала.
        if (result.signal) {
            if (result.signal === "SIGKILL") {
                console.log(chalk_1.default.red("The build failed because the process exited too early. " +
                    "This probably means the system ran out of memory or someone called `kill -9` on the process."));
                process.exit(1);
            }
            else if (result.signal === "SIGTERM") {
                console.log(chalk_1.default.bold.red("The build failed because the process exited too early. " +
                    "Someone might have called `kill` or `killall`, or the system could be shutting down."));
                process.exit(1);
            }
            process.exit(0);
        }
        process.env.NODE_ENV = NODE_ENV;
        console.log(chalk_1.default.green(`[ ${pkg.name} ][ INSTALL ][ END ]`));
        console.log("");
    });
}
exports.install = install;
