"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const child_process_1 = require("child_process");
const fs = require("fs");
const path = require("path");
const prettier_package_json = require("prettier-package-json");
// tslint:disable: variable-name
function prepare_assembly_for_deployment(rearguardConfig, target = "dist") {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(chalk_1.default.bold.blue(`[ PREPARE_ASSEMBLY_FOR_DEPLOYMENT ][ START ]`));
        console.log("");
        const { pkg } = rearguardConfig;
        const pkg_production = {
            private: true,
            // tslint:disable-next-line: object-literal-sort-keys
            engines: pkg.engines,
            dependencies: pkg.dependencies,
        };
        const pkg_path = path.resolve(process.cwd(), target, "package.json");
        const pkg_text = prettier_package_json.format(pkg_production);
        fs.writeFileSync(pkg_path, pkg_text.trim());
        const command = "npm install --production";
        console.log(chalk_1.default.white(command));
        console.log("");
        child_process_1.execSync(command, {
            cwd: path.resolve(process.cwd(), target),
            encoding: "utf8",
            stdio: "inherit",
        });
        console.log(chalk_1.default.bold.blue(`[ PREPARE_ASSEMBLY_FOR_DEPLOYMENT ][ END ]`));
        console.log("");
    });
}
exports.prepare_assembly_for_deployment = prepare_assembly_for_deployment;
