"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const copy = require("copy");
const moment = require("moment");
const path = require("path");
const const_1 = require("../../const");
function copy_bundles_to_dist(envConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        if (envConfig.isBuild && !(envConfig.has_dll || envConfig.has_browser_lib || envConfig.has_node_lib)) {
            console.log(chalk_1.default.bold.blue(`=========COPY_BUNDLE_TO_DIST===========`));
            console.log("");
            const startTime = moment();
            yield new Promise((resolve, reject) => {
                copy([`${path.resolve(process.cwd(), const_1.DLL_BUNDLE_DIR_NAME)}/**`], path.resolve(process.cwd(), const_1.DIST_DIR_NAME), (error, items) => {
                    if (!error) {
                        if (envConfig.isDebug) {
                            for (const item of items) {
                                console.log(chalk_1.default.white(`[ DLL ]`), chalk_1.default.bold.blue(item.path));
                            }
                        }
                        else {
                            console.log(chalk_1.default.white(`[ DLL ][ ${items.length} FILES ]`));
                        }
                        resolve();
                    }
                    else {
                        reject(error);
                    }
                });
            });
            yield new Promise((resolve, reject) => {
                copy([`${path.resolve(process.cwd(), const_1.LIB_BUNDLE_DIR_NAME)}/**`], path.resolve(process.cwd(), const_1.DIST_DIR_NAME), (error, items) => {
                    if (!error) {
                        if (envConfig.isDebug) {
                            for (const item of items) {
                                console.log(chalk_1.default.white(`[ LIBRARY ]`), chalk_1.default.bold.blue(item.path));
                            }
                        }
                        else {
                            console.log(chalk_1.default.white(`[ LIBRARY ][ ${items.length} FILES ]`));
                        }
                        resolve();
                    }
                    else {
                        reject(error);
                    }
                });
            });
            const endTime = moment();
            console.log("");
            console.log(chalk_1.default.bold.blue(`[ SPEED ][ ${endTime.diff(startTime, "milliseconds")} ms ]`));
            console.log(chalk_1.default.bold.blue(`=======================================`));
            console.log("");
        }
    });
}
exports.copy_bundles_to_dist = copy_bundles_to_dist;
