"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const del_1 = require("del");
const fs_1 = require("fs");
const lodash_1 = require("lodash");
const path = require("path");
const const_1 = require("../../const");
// tslint:disable:variable-name
function delete_bundles(envConfig, rearguardConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        const { pkg, has_dll, has_browser_lib, has_node_lib, is_application } = rearguardConfig;
        if (envConfig.isBuild && (has_dll || has_browser_lib || has_node_lib || is_application)) {
            const cur_bundle_name = lodash_1.snakeCase(pkg.name);
            const dll_bundle_dir = path.resolve(process.cwd(), const_1.DLL_BUNDLE_DIR_NAME);
            const lib_bundle_dir = path.resolve(process.cwd(), const_1.LIB_BUNDLE_DIR_NAME);
            const lib_dir = path.resolve(process.cwd(), const_1.LIB_DIR_NAME);
            const delete_target = [];
            if (fs_1.existsSync(lib_dir)) {
                delete_target.push(lib_dir);
            }
            if (fs_1.existsSync(dll_bundle_dir)) {
                for (const bundle_name of fs_1.readdirSync(dll_bundle_dir)) {
                    if (bundle_name !== cur_bundle_name) {
                        delete_target.push(path.resolve(process.cwd(), const_1.DLL_BUNDLE_DIR_NAME, bundle_name));
                    }
                }
            }
            if (fs_1.existsSync(lib_bundle_dir)) {
                for (const bundle_name of fs_1.readdirSync(lib_bundle_dir)) {
                    if (bundle_name !== cur_bundle_name) {
                        delete_target.push(path.resolve(process.cwd(), const_1.LIB_BUNDLE_DIR_NAME, bundle_name));
                    }
                }
            }
            const paths = yield del_1.default(delete_target);
            for (const item of paths) {
                console.log(chalk_1.default.gray(`[ LOCAL_COPY_OF_BUNDLE ][ REMOVE ][ ${path.relative(process.cwd(), item)} ]`));
            }
            console.log("");
        }
    });
}
exports.delete_bundles = delete_bundles;
// tslint:enable:variable-name
