"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const moment = require("moment");
const flatten_deps_1 = require("./flatten_deps");
const get_module_weight_1 = require("./get_module_weight");
// tslint:disable:variable-name
function get_list_of_ordered_modules(envConfig, a_root, a_modules, a_module_map) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(chalk_1.default.bold.blue(`============GET_LIST_OF_ORDERED_MODULES=========`));
        const startTime = moment();
        console.log(chalk_1.default.bold.blue(`[ GET_LIST_OF_ORDERED_MODULES ][ RUN ][ ${moment().format("YYYY-MM-DD hh:mm:ss")} ]`));
        console.log("");
        /////////////////////
        //
        // START OF PROCEDURE
        //
        /////////////////////
        const modules = flatten_deps_1.flatten_deps(envConfig, a_modules, a_root, a_module_map);
        const result = modules
            .map((module) => ({ name: module, weight: get_module_weight_1.get_module_weight(envConfig, module, 0, a_root, a_module_map) }))
            .sort((a, b) => (a.weight > b.weight ? 1 : -1))
            .map(({ name }) => name);
        /////////////////////
        //
        // END OF PROCEDURE
        //
        /////////////////////
        const endTime = moment();
        console.log(chalk_1.default.bold.blue(`[ GET_LIST_OF_ORDERED_MODULES ][ WORK_TIME ][ ${endTime.diff(startTime, "milliseconds")} ][ millisecond ]`));
        console.log(chalk_1.default.bold.blue(`[ GET_LIST_OF_ORDERED_MODULES ][ DONE ][ ${moment().format("YYYY-MM-DD hh:mm:ss")} ]`));
        console.log(chalk_1.default.bold.blue(`================================================`));
        console.log("");
        return result;
    });
}
exports.get_list_of_ordered_modules = get_list_of_ordered_modules;
// tslint:enable:variable-name
