"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const fs_1 = require("fs");
const path = require("path");
const RearguardConfig_1 = require("../../config/rearguard/RearguardConfig");
// tslint:disable:variable-name
function get_module_weight(envConfig, a_module_name, a_weight = 0, a_module_root, a_module_map) {
    function worker(a_module_path, weight) {
        const { sync_project_deps } = new RearguardConfig_1.RearguardConfig(envConfig, path.resolve(a_module_path, "package.json"));
        if (sync_project_deps.length > 0) {
            weight += sync_project_deps.length;
            for (const module_name of sync_project_deps) {
                weight += get_module_weight(envConfig, module_name, 0, a_module_root, a_module_map);
            }
            return weight;
        }
        else {
            return weight;
        }
    }
    if (utils_1.isString(a_module_root) && a_module_map) {
        const module_path = path.resolve(a_module_root, a_module_map.get(a_module_name) || "");
        if (fs_1.existsSync(module_path)) {
            return worker(module_path, a_weight);
        }
        else {
            console.log(chalk_1.default.bold.red(`[ GET_MODULE_WEIGHT ][ ERROR ][ You haven't module by path: ${module_path}; ]`));
            process.exit(1);
        }
    }
    const global_path = envConfig.resolveGlobalModule(a_module_name);
    const local_path = envConfig.resolveLocalModule(a_module_name);
    if (fs_1.existsSync(global_path)) {
        return worker(global_path, a_weight);
    }
    if (fs_1.existsSync(local_path)) {
        return worker(local_path, a_weight);
    }
    console.log(chalk_1.default.bold.red(`[ GET_MODULE_WEIGHT ][ ERROR ][ You haven't link in local node_modules ${global_path}; ]`));
    console.log(chalk_1.default.bold.red(`[ GET_MODULE_WEIGHT ][ ERROR ][ You haven't link in global node_modules ${global_path}; ]`));
    process.exit(1);
    return 0;
}
exports.get_module_weight = get_module_weight;
// tslint:enable:variable-name
