"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const child_process_1 = require("child_process");
const path = require("path");
const RearguardConfig_1 = require("../../config/rearguard/RearguardConfig");
const check_npm_1 = require("../check_npm");
function install_declared_deps(envConfig, CWD = process.cwd()) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const { sync_project_deps, pkg } = new RearguardConfig_1.RearguardConfig(envConfig, path.resolve(CWD, "package.json"));
            if (sync_project_deps.length > 0) {
                console.log(chalk_1.default.bold.blue(`===========INSTALL_DECLARED_DEPS============`));
                console.log("");
                /////////////////////
                //
                // * START OF PROCEDURE
                //
                /////////////////////
                const deps = Object.keys(pkg.dependencies || {});
                const devDeps = Object.keys(pkg.devDependencies || {});
                const peerDeps = Object.keys(pkg.peerDependencies || {});
                const installList = [];
                for (const depName of sync_project_deps) {
                    if (!deps.includes(depName) && !devDeps.includes(depName) && !peerDeps.includes(depName)) {
                        installList.push(depName);
                    }
                }
                if (installList.length > 0) {
                    const npmIsAvailable = yield check_npm_1.check_npm();
                    if (npmIsAvailable) {
                        const command = `npm install ${installList.join(" ")}`;
                        console.log(chalk_1.default.white(command));
                        console.log("");
                        child_process_1.execSync(command, {
                            cwd: process.cwd(),
                            encoding: "utf8",
                            stdio: "inherit",
                        });
                        console.log("");
                        return true;
                    }
                }
                else {
                    console.log(chalk_1.default.white(`Dependencies alredy installed`));
                    console.log("");
                }
                /////////////////////
                //
                // * END OF PROCEDURE
                //
                /////////////////////
                console.log(chalk_1.default.bold.blue(`============================================`));
                console.log("");
            }
        }
        catch (error) {
            console.trace(chalk_1.default.red(`[ ERROR_MESSAGE: ${utils_1.getErrorMessage(error)} ]`));
            process.exit(1);
        }
        return false;
    });
}
exports.install_declared_deps = install_declared_deps;
