"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const rearguard_1 = require("../../config/rearguard");
const flatten_deps_1 = require("./flatten_deps");
const get_module_weight_1 = require("./get_module_weight");
// tslint:disable:variable-name
function ordering_project_deps(envConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        let sync_project_deps = rearguard_1.rearguardConfig.sync_project_deps;
        if (sync_project_deps.length > 0) {
            console.log(chalk_1.default.bold.blue(`[ ORDERINNG_PROJECT_DEPS ][ START ]`));
            console.log("");
            /////////////////////
            //
            // * START OF PROCEDURE
            //
            /////////////////////
            const modules = flatten_deps_1.flatten_deps(envConfig, sync_project_deps);
            sync_project_deps = modules
                .map((module) => ({ name: module, weight: get_module_weight_1.get_module_weight(envConfig, module, 0) }))
                .sort((a, b) => (a.weight > b.weight ? 1 : -1))
                .map(({ name }) => name);
            rearguard_1.rearguardConfig.sync_project_deps = sync_project_deps;
            /////////////////////
            //
            // * END OF PROCEDURE
            //
            /////////////////////
            console.log(chalk_1.default.bold.blue(`[ ORDERINNG_PROJECT_DEPS ][ END ]`));
            console.log("");
        }
    });
}
exports.ordering_project_deps = ordering_project_deps;
// tslint:enable:variable-name
