"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
const prettier = require("prettier");
const const_1 = require("../../const");
const helpers_1 = require("../../helpers");
const get_bundles_info_1 = require("./get_bundles_info");
// tslint:disable:variable-name
function set_list_of_modules_with_deferred_loading(envConfig, rearguardConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        const bundles_info = get_bundles_info_1.get_bundles_info(envConfig, rearguardConfig);
        let source = "/* tslint:disable */\r";
        let need_write = false;
        for (const info of bundles_info) {
            if (info.load_on_demand) {
                const dll_name = helpers_1.dll_entry_name(info.bundle_name);
                const lib_name = helpers_1.lib_entry_name(info.bundle_name);
                if (info.has_dll && info.has_browser_lib) {
                    const dll_public_path = require(info.assets.dll)[dll_name].js;
                    const lib_public_path = require(info.assets.lib)[lib_name].js;
                    source +=
                        `export const ${info.bundle_name}: { dll: string[], lib: string[] } = ` +
                            `{ dll: [ "${dll_name}" , "${dll_public_path}" ], lib: [ "${lib_name}", "${lib_public_path}" ] } \r`;
                    need_write = true;
                }
                if (!info.has_dll && info.has_browser_lib) {
                    const lib_public_path = require(info.assets.lib)[lib_name].js;
                    source += `export const ${info.bundle_name} = { lib: [ "${lib_name}", "${lib_public_path}" ] } \r`;
                    need_write = true;
                }
            }
        }
        source += "/* tslint:enable */\r\n";
        if (need_write) {
            fs_1.writeFileSync(path_1.resolve(process.cwd(), "src", const_1.DEFERRED_MODULE_LIST), prettier.format(source).trim(), {
                encoding: "utf-8",
            });
        }
    });
}
exports.set_list_of_modules_with_deferred_loading = set_list_of_modules_with_deferred_loading;
// tslint:enable:variable-name
