"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
function show_docker_commands(rearguardConfig) {
    const { pkg, docker_org_name } = rearguardConfig;
    console.log(chalk_1.default.bold.magenta(`========================================`));
    console.log("");
    console.log(chalk_1.default.bold.magenta(`[ COMMANDS FOR DEPLOYING DOCKER ]`));
    console.log("");
    console.log(chalk_1.default.bold.magenta(`[ BUILD IMAGE ]`));
    console.log(chalk_1.default.bold.cyan(`docker build --no-cache -f ./build/Dockerfile -t ${docker_org_name}/${pkg.name}:${pkg.version} .`));
    console.log("");
    console.log(chalk_1.default.bold.magenta(`[ PUSH IMAGE ]`));
    console.log(chalk_1.default.bold.cyan(`docker push ${docker_org_name}/${pkg.name}:${pkg.version}`));
    console.log("");
    console.log(chalk_1.default.bold.magenta(`[ DOCKER-COMPOSE.YML EXAMPLE ]`));
    console.log(chalk_1.default.bold.cyan(`cat ./examples/docker-compose.yml`));
    console.log("");
    console.log(chalk_1.default.bold.magenta(`========================================`));
    console.log("");
}
exports.show_docker_commands = show_docker_commands;
