"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const path_1 = require("path");
const workboxBuild = require("workbox-build");
const helpers_1 = require("../helpers");
const generateSW = workboxBuild.generateSW;
function create_workbox(envConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(chalk_1.default.bold.yellowBright(`[ WORKBOX ][ START ]`));
        const swDest = path_1.resolve(helpers_1.get_output_path(), "sw.js");
        // tslint:disable-next-line: variable-name
        const glob_for_files = "*.{js,css,html,jpeg,jpg,svg,gif,png,ttf}";
        yield generateSW({
            cleanupOutdatedCaches: true,
            clientsClaim: true,
            globDirectory: helpers_1.get_output_path(),
            globPatterns: [`**/${envConfig.isDevelopment ? "dev" : "prod"}/${glob_for_files}`, glob_for_files],
            importWorkboxFrom: "local",
            maximumFileSizeToCacheInBytes: 20 * 1024 * 1024,
            navigateFallback: "/",
            skipWaiting: true,
            swDest,
        }).then(({ count, size }) => {
            console.log(chalk_1.default.bold.yellowBright(`[ SERVICE_WORKER ][ ${swDest} ]`));
            console.log(chalk_1.default.bold.yellowBright(`[ PRECACHE ][ ${count} ][ FILES ]`));
            console.log(chalk_1.default.bold.yellowBright(`[ SIZE ][ ${size / 1024} ][ KB ]`));
        });
        console.log(chalk_1.default.bold.yellowBright(`[ WORKBOX ][ END ]`));
        console.log("");
    });
}
exports.create_workbox = create_workbox;
