"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const fs = require("fs");
const path = require("path");
const const_1 = require("../const");
// tslint:disable:variable-name
class NonVersionableConfig {
    constructor(config_path) {
        this.config_path = path.resolve(process.cwd(), const_1.NON_VERSIONABLE_CONFIG_FILE_NAME);
        if (utils_1.isString(config_path) && fs.existsSync(config_path)) {
            this.config_path = config_path;
        }
    }
    get config() {
        if (fs.existsSync(this.config_path)) {
            try {
                return JSON.parse(fs.readFileSync(this.config_path).toString());
            }
            catch (error) {
                fs.writeFileSync(this.config_path, JSON.stringify({}, null, 2).trim());
                console.log(chalk_1.default.greenBright(`[ NON-VERSIONABLE-CONFIG ][ CREATED ][ ${this.config_path} ]`));
                console.log("");
                return {};
            }
        }
        else {
            fs.writeFileSync(this.config_path, JSON.stringify({}, null, 2).trim());
            console.log(chalk_1.default.greenBright(`[ NON-VERSIONABLE-CONFIG ][ CREATED ][ ${this.config_path} ]`));
            console.log("");
            return this.config;
        }
    }
    set config(fields) {
        fs.writeFileSync(this.config_path, JSON.stringify(Object.assign({}, this.config, fields), null, 2).trim());
    }
}
exports.NonVersionableConfig = NonVersionableConfig;
// tslint:enable:variable-name
