"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const NonVersionableConfig_1 = require("../NonVersionableConfig");
class AnalyzeConfig extends NonVersionableConfig_1.NonVersionableConfig {
    get port() {
        const { analyze } = this.config;
        if (analyze) {
            const { port } = analyze;
            if (utils_1.isNumber(port) && port > 5000) {
                return port;
            }
            else {
                console.log("");
                console.log(chalk_1.default.bold.yellow(`[ ANALYZE_CONFIG ][ WARNING ][ PORT ][ MUST_BE_A_NUMBER AND MORE THEN 5000 ]`));
            }
        }
        else {
            console.log("");
            console.log(chalk_1.default.bold.yellow(`[ ANALYZE_CONFIG ][ WARNING ][ ANALYZE ][ MUST_BE_DEFINED ]`));
        }
        this.config = { analyze: { port: 10000 } };
        console.log("");
        console.log(chalk_1.default.bold.green(`[ ANALYZE_CONFIG ][ ASSIGN ][ PORT ][ TO 10000 ]`));
        return this.port;
    }
}
exports.AnalyzeConfig = AnalyzeConfig;
