"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
class EnvConfig {
    constructor() {
        this.resolveLocalModule = this.resolveLocalModule.bind(this);
        this.resolveGlobalModule = this.resolveGlobalModule.bind(this);
        this.resolveDevModule = this.resolveDevModule.bind(this);
    }
    get isInit() {
        return process.env.REARGUARD_LAUNCH_IS_INIT === "true";
    }
    get isWDS() {
        return process.env.REARGUARD_LAUNCH_IS_WDS === "true";
    }
    get isSync() {
        return process.env.REARGUARD_LAUNCH_IS_SYNC === "true";
    }
    get isBNS() {
        return process.env.REARGUARD_LAUNCH_IS_BUILD_NODE_SERVER === "true";
    }
    get isSNS() {
        return process.env.REARGUARD_LAUNCH_IS_START_NODE_SERVER === "true";
    }
    get isBuild() {
        return process.env.REARGUARD_LAUNCH_IS_BUILD === "true";
    }
    get isDebug() {
        return process.env.REARGUARD_DEBUG === "true";
    }
    get isWatch() {
        return process.env.REARGUARD_WATCH === "true";
    }
    get force() {
        return process.env.REARGUARD_FORCE === "true";
    }
    get needUpdateBuildTime() {
        return process.env.REARGUARD_NEED_UPDATE_BUILD_TIME === "true";
    }
    get install_deps() {
        return process.env.REARGUARD_INSTALL_DEPS === "true";
    }
    get is_application() {
        return process.env.REARGUARD_IS_APPLICATION === "true";
    }
    get is_back_end() {
        return process.env.REARGUARD_IS_BACK_END === "true";
    }
    get has_dll() {
        return process.env.REARGUARD_DLL === "true";
    }
    get has_node_lib() {
        return process.env.REARGUARD_NODE_LIB === "true";
    }
    get has_browser_lib() {
        return process.env.REARGUARD_BROWSER_LIB === "true";
    }
    get load_on_demand() {
        return process.env.REARGUARD_LOAD_ON_DEMAND === "true";
    }
    get isDevelopment() {
        return process.env.NODE_ENV === "development";
    }
    get isBuildBoth() {
        return process.env.REARGUARD_BUILD_BOTH === "true";
    }
    get localNodeModulePath() {
        return process.env.REARGUARD_LOCAL_NODE_MODULE_PATH || "";
    }
    get globalNodeModulePath() {
        return process.env.REARGUARD_GLOBAL_NODE_MODULES_PATH || "";
    }
    get devNodeModulePath() {
        return process.env.REARGUARD_DEV_NODE_MODULE_PATH || "";
    }
    get rootDir() {
        return process.cwd();
    }
    /**
     * MONO_REPOSITORY
     */
    get is_mono_init() {
        return process.env.REARGUARD_MONO_INIT === "true";
    }
    get is_mono_clear() {
        return process.env.REARGUARD_MONO_CLEAR === "true";
    }
    get is_mono_install() {
        return process.env.REARGUARD_MONO_INSTALL === "true";
    }
    get is_mono_build() {
        return process.env.REARGUARD_MONO_BUILD === "true";
    }
    get is_mono_link() {
        return process.env.REARGUARD_MONO_LINK === "true";
    }
    get is_mono_bootstrap() {
        return process.env.REARGUARD_MONO_BOOTSTRAP === "true";
    }
    get is_mono_test() {
        return process.env.REARGUARD_MONO_TEST === "true";
    }
    get is_mono_publish() {
        return process.env.REARGUARD_MONO_PUBLISH === "true";
    }
    get is_mono_publish_patch() {
        return process.env.REARGUARD_MONO_PUBLISH_PATH === "true";
    }
    get is_mono_publish_minor() {
        return process.env.REARGUARD_MONO_PUBLISH_MINOR === "true";
    }
    get is_mono_publish_major() {
        return process.env.REARGUARD_MONO_PUBLISH_MAJOR === "true";
    }
    /**
     * END
     */
    resolveLocalModule(name) {
        return path.resolve(this.localNodeModulePath, name);
    }
    resolveGlobalModule(name) {
        return path.resolve(this.globalNodeModulePath, name);
    }
    resolveDevModule(name) {
        return path.resolve(this.devNodeModulePath, name);
    }
}
exports.EnvConfig = EnvConfig;
