"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
const ConfigFile_1 = require("../ConfigFile");
class MonorepoConfig extends ConfigFile_1.ConfigFile {
    constructor() {
        super("monorepo.json");
    }
    get default_config() {
        return {
            modules: "modules",
        };
    }
    get modules() {
        const { modules } = this.config;
        if (util_1.isString(modules) && modules.length > 0) {
            return modules;
        }
        console.error("[ MONOREPO_CONFIG_FILE ][ MODULES ][ ERROR ][ modules should be not empty string ]");
        return "";
    }
}
exports.MonorepoConfig = MonorepoConfig;
