"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const VersionableConfig_1 = require("../VersionableConfig");
class PkgInfo extends VersionableConfig_1.VersionableConfig {
    get name() {
        const { name } = this.pkg;
        if (utils_1.isString(name) && name.length > 0) {
            return name;
        }
        console.log(chalk_1.default.bold.red(`[ PKG_INFO ][ ERROR ][ name ][ MUST_BE_A_NON_EMPTY_STRING ]`));
        console.log(chalk_1.default.bold.red(JSON.stringify(this.pkg, null, 2)));
        process.exit(1);
        return "";
    }
    get engines() {
        const { engines } = this.pkg;
        if (!utils_1.isObject(engines) || (utils_1.isObject(engines) && Object.keys(engines).length === 0)) {
            this.pkg = {
                engines: {
                    node: ">=10",
                    npm: ">=6",
                },
            };
        }
        return this.engines;
    }
    get nodeVersion() {
        return parseFloat(this.pkg.engines.node.match(/(\d+\.?)+/)[0]);
    }
    get dependencies() {
        const { dependencies } = this.pkg;
        if (dependencies) {
            return dependencies;
        }
        this.pkg = { dependencies: {} };
        return this.dependencies;
    }
}
exports.PkgInfo = PkgInfo;
