"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const const_1 = require("../../const");
const helpers_1 = require("../../helpers");
const ConfigFile_1 = require("../ConfigFile");
const rearguard_1 = require("../rearguard");
// tslint:disable:variable-name object-literal-sort-keys
class TypescriptConfig extends ConfigFile_1.ConfigFile {
    constructor(envConfig, file_name = const_1.TS_CONFIG_FILE_NAME) {
        super(file_name);
        this.envConfig = envConfig;
    }
    get default_config() {
        const { isDebug } = this.envConfig;
        return Object.assign({ compileOnSave: false, compilerOptions: Object.assign({ 
                /* Base options */
                baseUrl: helpers_1.get_context(), allowSyntheticDefaultImports: true, forceConsistentCasingInFileNames: true, target: "es6", jsx: "react", lib: ["dom", "es6", "DOM.Iterable", "ScriptHost", "es7"], module: this.envConfig.isSync || this.envConfig.isBNS || this.envConfig.isSNS ? "commonjs" : "es6", moduleResolution: "node", importHelpers: true, noErrorTruncation: true }, (!rearguard_1.rearguardConfig.has_node_lib && !rearguard_1.rearguardConfig.is_application && rearguard_1.rearguardConfig.has_browser_lib
                ? {
                    declaration: true,
                    outDir: path.resolve(process.cwd(), const_1.LIB_DIR_NAME),
                }
                : {}), { 
                /* Strict Type-Checking Options */
                strict: true /*
                  Enable all strict type checking options.
                  Enabling --strict enables
                  --noImplicitAny,
                  --noImplicitThis,
                  --alwaysStrict,
                  --strictNullChecks,
                  --strictFunctionTypes
                  --strictPropertyInitialization.
                   */, noImplicitReturns: true /* Report error when not all code paths in function return a value. */, noImplicitAny: false /** Raise error on expressions and declarations with an implied any type. */, strictPropertyInitialization: false, 
                /* Experimental Options */
                experimentalDecorators: true, emitDecoratorMetadata: true, 
                /* Debug Options */
                diagnostics: isDebug, extendedDiagnostics: isDebug, traceResolution: isDebug, skipLibCheck: true }), include: [helpers_1.get_context(), path.resolve(helpers_1.get_context(), "../bin")], exclude: [
                "node_modules",
                ...((this.envConfig.isWDS || this.envConfig.isBuild) && !(this.envConfig.isSync || this.envConfig.isBNS)
                    ? [
                        path.resolve(process.cwd(), const_1.DLL_BUNDLE_DIR_NAME),
                        path.resolve(process.cwd(), const_1.LIB_BUNDLE_DIR_NAME),
                        path.resolve(process.cwd(), const_1.LIB_DIR_NAME),
                    ]
                    : []),
            ] }, (this.envConfig.isSync || this.envConfig.isBNS
            ? { include: [path.resolve(process.cwd(), "bin"), path.resolve(process.cwd(), "src")] }
            : {}));
    }
}
exports.TypescriptConfig = TypescriptConfig;
// tslint:enable:variable-name
