"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const const_1 = require("../../const");
const helpers_1 = require("../../helpers");
const TypescriptConfig_1 = require("./TypescriptConfig");
// tslint:disable:variable-name object-literal-sort-keys
class TypescriptTestConfig extends TypescriptConfig_1.TypescriptConfig {
    constructor(envConfig) {
        super(envConfig, const_1.TEST_TS_CONFIG_FILE_NAME);
    }
    get default_config() {
        return {
            compileOnSave: super.default_config.compileOnSave,
            compilerOptions: Object.assign({}, super.default_config.compilerOptions, { module: "commonjs" }),
            include: [...super.default_config.include, path.resolve(helpers_1.get_context(), "..", const_1.TESTS_DIR_NAME)],
            exclude: [...super.default_config.exclude],
        };
    }
}
exports.TypescriptTestConfig = TypescriptTestConfig;
// tslint:enable:variable-name
