"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const NonVersionableConfig_1 = require("../NonVersionableConfig");
class WDSConfig extends NonVersionableConfig_1.NonVersionableConfig {
    get host() {
        const { host } = this.wds;
        if (utils_1.isString(host) && host.length > 0) {
            return host;
        }
        console.log("");
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ HOST ][ WARNING ][ must be a not empty string ]`));
        this.wds = { host: "localhost" };
        console.log(chalk_1.default.bold.green(`[ CONFIG ][ HOST ][ ASSIGN_TO ][ 'localhost' ]`));
        return this.host;
    }
    get port() {
        const { port } = this.wds;
        if (utils_1.isNumber(port)) {
            return port;
        }
        console.log("");
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ PORT ][ WARNING ][ must be a number ]`));
        this.wds = { port: 3000 };
        console.log(chalk_1.default.bold.green(`[ CONFIG ][ PORT ][ ASSIGN_TO ][ 3000 ]`));
        return this.port;
    }
    get proxy() {
        const { proxy } = this.wds;
        if (utils_1.isObject(proxy) && Object.keys(proxy).length > 0) {
            return proxy;
        }
        console.log("");
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ PROXY ][ WARNING ][ must be defined ]`));
        this.wds = {
            proxy: {
                "/service": "http://localhost:10000",
                "/ws": {
                    changeOrigin: true,
                    target: "ws://localhost:10001",
                    ws: true,
                },
            },
        };
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ PROXY ][ ASSIGN_TO ][ default ]`));
        return this.proxy;
    }
    get wds() {
        const { wds } = this.config;
        if (wds) {
            return wds;
        }
        console.log("");
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ WDS ][ WARNING ][ must be defined ]`));
        this.config = { wds: {} };
        console.log(chalk_1.default.bold.yellow(`[ CONFIG ][ WDS ][ WRITE ][ assign to '{}' ]`));
        return this.wds;
    }
    set wds(params) {
        this.config = { wds: Object.assign({}, this.wds, params) };
    }
}
exports.WDSConfig = WDSConfig;
