"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const path = require("path");
const env_1 = require("./config/env");
const pkg_1 = require("./config/pkg");
const rearguard_1 = require("./config/rearguard");
const const_1 = require("./const");
// CONTEXT
function get_context() {
    return path.resolve(process.cwd(), rearguard_1.rearguardConfig.context);
}
exports.get_context = get_context;
function get_output_path() {
    return path.resolve(process.cwd(), rearguard_1.rearguardConfig.output.path);
}
exports.get_output_path = get_output_path;
function dll_entry_name(name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return `___DLL___${name}`;
}
exports.dll_entry_name = dll_entry_name;
function lib_entry_name(name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return `___LIBRARY___${name}`;
}
exports.lib_entry_name = lib_entry_name;
function dll_output_path(root = env_1.envConfig.rootDir, name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return path.resolve(root, const_1.DLL_BUNDLE_DIR_NAME, name, const_1.BUNDLE_SUB_DIR());
}
exports.dll_output_path = dll_output_path;
function lib_output_path(root = env_1.envConfig.rootDir, name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return path.resolve(root, const_1.LIB_BUNDLE_DIR_NAME, name, const_1.BUNDLE_SUB_DIR());
}
exports.lib_output_path = lib_output_path;
function dll_assets_path(root = env_1.envConfig.rootDir, name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return path.resolve(dll_output_path(root, name), const_1.ASSETS_NAME);
}
exports.dll_assets_path = dll_assets_path;
function lib_assets_path(root = env_1.envConfig.rootDir, name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return path.resolve(lib_output_path(root, name), const_1.ASSETS_NAME);
}
exports.lib_assets_path = lib_assets_path;
function dll_manifest_path(root = env_1.envConfig.rootDir, name = lodash_1.snakeCase(pkg_1.pkgInfo.name)) {
    return path.resolve(dll_output_path(root, name), const_1.DLL_MANIFEST_NAME);
}
exports.dll_manifest_path = dll_manifest_path;
