"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@borodindmitriy/utils");
const chalk_1 = require("chalk");
const fs = require("fs");
const mkdirp = require("mkdirp");
const path = require("path");
class MetaFile {
    constructor(destFile, srcFile) {
        this.destFile = destFile;
        this.srcFile = utils_1.isString(srcFile) ? srcFile : destFile;
    }
    init(envConfig, force = false) {
        const src = path.resolve(__dirname, "../../../templates", this.srcFile);
        const dest = path.resolve(process.cwd(), this.destFile);
        const hasFile = fs.existsSync(dest);
        mkdirp.sync(path.dirname(dest));
        if (!hasFile || envConfig.force || force) {
            fs.copyFileSync(src, dest);
            if (hasFile && (envConfig.force || force)) {
                console.log(chalk_1.default.yellow(`[ META_FILE ][ FORCE_INIT ][ ${dest} ]`));
            }
            if (!hasFile) {
                console.log(chalk_1.default.green(`[ META_FILE ][ INIT ][ ${dest} ]`));
            }
        }
    }
}
exports.MetaFile = MetaFile;
