"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const fs = require("fs");
const path = require("path");
class GitIgnore {
    constructor(rearguardConfig) {
        // DEPS
        this.rearguardConfig = rearguardConfig;
        // BINDS
        this.init = this.init.bind(this);
    }
    init(envConfig, force = false) {
        const dest = path.resolve(process.cwd(), ".gitignore");
        const hasFile = fs.existsSync(dest);
        let gitignore = [`node_modules`, `.env`, `deferred_module_list.ts`, "examples"];
        if (!this.rearguardConfig.publish_in_git) {
            gitignore.push("dll_bundle");
            gitignore.push("lib_bundle");
            gitignore.push("lib");
        }
        gitignore = gitignore.concat([
            "dist",
            "rearguard.json",
            "tsconfig.json",
            "tslint.json",
            "src/typings.d.ts",
            ".dockerignore",
            ".editorconfig",
            ".npmrc",
            "pre_publish.sh",
            "pre_publish_build_tmp",
        ]);
        if (!hasFile || envConfig.force || force) {
            fs.writeFileSync(path.resolve(process.cwd(), ".gitignore"), gitignore.join("\r\n").trim());
            if (hasFile && (envConfig.force || force)) {
                console.log(chalk_1.default.yellow(`[ META_FILE ][ FORCE_INIT ][ ${dest} ]`));
            }
            if (!hasFile) {
                console.log(chalk_1.default.green(`[ META_FILE ][ CREATE ][ ${dest} ]`));
            }
        }
    }
}
exports.GitIgnore = GitIgnore;
