"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const watch_deps_1 = require("../../components/watch_deps");
const wds_1 = require("../../config/wds");
const const_1 = require("../../const");
const get_stats_1 = require("./get_stats");
// tslint:disable:object-literal-sort-keys
function get_WDS_config(envConfig, rearguardConfig) {
    const { proxy } = wds_1.wdsConfig;
    const { output } = rearguardConfig;
    return {
        bonjour: true,
        compress: true,
        contentBase: [path.resolve(process.cwd(), const_1.DLL_BUNDLE_DIR_NAME), path.resolve(process.cwd(), const_1.LIB_BUNDLE_DIR_NAME)],
        watchContentBase: false,
        before(app, server) {
            watch_deps_1.watch_deps_event_emitter.on("SYNCED", () => {
                server.middleware.waitUntilValid(() => {
                    server.sockWrite(server.sockets, "content-changed");
                });
            });
        },
        historyApiFallback: true,
        hot: true,
        https: true,
        open: true,
        overlay: false,
        proxy,
        publicPath: output.publicPath,
        stats: get_stats_1.get_stats(envConfig),
    };
}
exports.get_WDS_config = get_WDS_config;
// tslint:enable:object-literal-sort-keys
