"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslint_1 = require("../../config/tslint");
const typescript_1 = require("../../config/typescript");
const helpers_1 = require("../../helpers");
exports.default = () => {
    const include = [helpers_1.get_context()];
    const test = /\.(ts|tsx)?$/;
    return [
        {
            enforce: "pre",
            include,
            loader: "tslint-loader",
            options: {
                configFile: tslint_1.tsLintConfig.config_path,
            },
            test,
        },
        {
            include,
            test,
            use: [
                {
                    loader: "ts-loader",
                    options: {
                        configFile: typescript_1.typescriptConfig.config_path,
                    },
                },
            ],
        },
    ];
};
