"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const buildStatus_1 = require("../config/buildStatus");
const const_1 = require("../const");
const helpers_1 = require("../helpers");
const js_plugins_1 = require("./components/js.plugins");
const ts_loaders_1 = require("./components/ts.loaders");
const webpack_config_common_1 = require("./webpack.config.common");
// tslint:disable:object-literal-sort-keys
function library_WP_config(envConfig, rearguardConfig) {
    const { lib_entry, bundle_public_path } = rearguardConfig;
    return webpack_config_common_1.general_WP_config(envConfig, rearguardConfig, {
        [helpers_1.lib_entry_name()]: path.resolve(helpers_1.get_context(), lib_entry),
    }, {
        // path - путь куда записываются файлы.
        path: helpers_1.lib_output_path(),
        // publicPath - путь до ресурса с файлами.
        publicPath: bundle_public_path,
        library: helpers_1.lib_entry_name(),
        libraryTarget: "var",
    }, ts_loaders_1.default(), [
        ...js_plugins_1.DllReferencePlugin(envConfig, rearguardConfig),
        ...js_plugins_1.assetsPlugin(envConfig, const_1.LIB_BUNDLE_DIR_NAME),
        ...js_plugins_1.analyze(envConfig),
        ...js_plugins_1.clean(envConfig, [helpers_1.lib_output_path()]),
        new js_plugins_1.HashWebpackPlugin(buildStatus_1.buildStatusConfig, envConfig),
    ], {});
}
exports.library_WP_config = library_WP_config;
// tslint:enable:object-literal-sort-keys
