"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const buildStatus_1 = require("../config/buildStatus");
const const_1 = require("../const");
const entry_1 = require("./components/entry");
const js_plugins_1 = require("./components/js.plugins");
const ts_loaders_1 = require("./components/ts.loaders");
const webpack_config_common_1 = require("./webpack.config.common");
// tslint:disable:object-literal-sort-keys
function main_WS_config(envConfig, rearguardConfig) {
    const { output } = rearguardConfig;
    return webpack_config_common_1.general_WP_config(envConfig, rearguardConfig, entry_1.default(), {
        // path - путь куда записываются файлы.
        path: output.path,
        // publicPath - путь до ресурса с файлами.
        publicPath: output.publicPath,
    }, ts_loaders_1.default(), [
        ...js_plugins_1.clean(envConfig, [const_1.DIST_DIR_NAME]),
        ...js_plugins_1.DllReferencePlugin(envConfig, rearguardConfig),
        ...js_plugins_1.HMR(envConfig),
        ...js_plugins_1.htmlWebpackPlugin(envConfig, rearguardConfig),
        ...js_plugins_1.analyze(envConfig),
        new js_plugins_1.HashWebpackPlugin(buildStatus_1.buildStatusConfig, envConfig),
    ], {});
}
exports.main_WS_config = main_WS_config;
// tslint:enable:object-literal-sort-keys
